Elektroda.pl
Elektroda.pl
X

Search our partners

Find the latest content on electronic components. Datasheets.com
Elektroda.pl
Please add exception to AdBlock for elektroda.pl.
If you watch the ads, you support portal and users.

SAT dekoder na Linuxie Restart dekodera i kwestia zewn IP od VPNa a serwis Oscam

Gregory* 23 Feb 2020 16:28 999 8
Computer Controls
  • #1
    Gregory*
    Level 10  
    Witam!
    Prośba o pomoc w konfiguracji dekodera Octagon SF8008, skonfigurowałem moduł OpenVPNa korzystając z pliku .ovpn od mojego dostawcy ustawiając na sztywno jeden VPNowych serwerów wedle IP.
    Komenda: curl https://ipinfo.io/ip prawidłowo wskazuje zewnętrzne IP dekodera.

    Sprawdzając jednak jakie zewnętrzne IP ma mój dekoder po restarcie z użyciem crontaba:
    @reboot curl https://ipinfo.io/ip >> /home/root/plik_ip.txt

    Zauważyłem, że output powyższej komendy daje moje własne zewnętrzne IP a nie tego VPNowego, po paru sekundach kiedy loguje się do dekodera przez ssh i w bashu wpisuje curl https://ipinfo.io/ip, wynik jest poprawny czyli ten VPNowy.

    Czy jest możliwość konfiguracji takiej aby uzyskanie zewnętrznego IP od dostawcy VPNa było pierwszym serwisem po restarcie ?
    ewentualnie jak opóźnić wystartowanie usługi oscam na samym dekoderze tak aby był odpalany po module OpenVPN ?

    dzięki
  • Computer Controls
  • Computer Controls
  • #3
    Gregory*
    Level 10  
    przeqpiciel wrote:
    czy usługi openvpn i odpowiadającą za dekoder odpalasz przez systemd ? co to za linux tam jest ?


    To jest jakiś lekko okrojona dystrybucja Linuxa tzw. Enigma2 przeznaczona na dekodery telewizji SAT
    Linux sf8008 4.4.35 #1 SMP Wed Jun 26 03:47:04 CEST 2019 armv7l GNU/Linux
    Linux version 4.4.35 (oe-user@oe-host) (gcc version 6.3.0 (GCC) ) #1 SMP Wed Jun 26 03:47:04 CEST 2019


    jakiś engine tuxbox, moja nakładka GUI na to to tzw. OpenATV, ten Linux ma manger pakietów opkg,
    jest tam problem nawet z uruchomieniem iptables, mój problem w innym topicu: https://www.elektroda.pl/rtvforum/viewtopic.php?p=18481382

    konfig OpenVPNa wrzuciłe do pliku /etc/openvpn/client.conf, gotowy .opvpn z modyfikacją aby login/passwd zaciągał z pliku txt "auth-user-pass", odnośnie systemd to nie wiem..
  • #5
    Gregory*
    Level 10  
    przeqpiciel wrote:
    Code:

    @reboot sleep 30; curl https://ipinfo.io/ip >> /home/root/plik_ip.txt


    pokza status uslugi
    Code:

    systemctl status oscam


    sleep 3 daje juz poprawne openVPNowe IP, a usługi systemctl w ogóle nie ma: -bash: systemctl: command not found[i]

    a odnośnie serwisów jakie startują przy bootowaniu, ten plugin oscam-stable który mam zainstalowany na dekoderze znajduje się w katalogu /etc/init.d
    czy tu przypadkiem nie dałoby się to jakoś podrasować z delayem startu ?

    cat softcam.oscam-stable daje:

    Quote:
    #!/bin/sh
    ### BEGIN INIT INFO
    # Provides: softcam
    # Required-Start: $local_fs
    # Required-Stop:
    # Should-Start: $time $remote_fs cardserver
    # Should-Stop:
    # Default-Start: 2 3 4 5
    # Default-Stop: 0 1 6
    # Short-Description: oscam
    # Description: oscam SoftCAM, card reader and server.
    ### END INIT INFO

    readlink -f $0 >/dev/null 2>&1
    if [ $? -eq 0 ]; then
    CAM=$(basename $(readlink -f $0) | sed s#^softcam\.##)
    else
    CAM=$(basename $0 | sed s#^softcam\.##)
    fi

    [ -n "$CAM" ] || exit 1
    [ -x /usr/bin/$CAM ] || exit 1

    PIDFILE=/var/tmp/${CAM}.pid
    DESC="Softcam service $CAM"
    DAEMON=/usr/bin/$CAM

    case "$1" in
    start)
    if [ -e $PIDFILE ]; then
    PIDDIR=/proc/$(cat $PIDFILE)
    if [ -d ${PIDDIR} ] && [[ $(readlink -f ${PIDDIR}/exe) == $DAEMON ]]; then
    echo "$DESC already started; not starting."
    exit 1
    else
    rm -f $PIDFILE
    fi
    fi
    echo -n "Starting $DESC: "
    ulimit -s 1024
    $DAEMON --config-dir /etc/tuxbox/config/$CAM --daemon --pidfile $PIDFILE --restart 2 --utf8 2| grep -v "UTF-8 mode"
    sleep 0.5
    RETVAL=1
    [ -e $PIDFILE ] && RETVAL=0
    if [ "$RETVAL" -eq "0" ]; then
    echo "OK"
    else
    echo "FAILED"
    fi
    exit $RETVAL
    ;;
    stop)
    echo -n "Stopping $DESC: "
    kill `cat $PIDFILE 2> /dev/null` 2> /dev/null
    RETVAL=$?
    if [ "$RETVAL" -eq "0" ]; then
    echo "OK"
    else
    echo "FAILED"
    fi
    sleep 1
    killall $CAM 2> /dev/null
    exit $RETVAL
    ;;
    restart|reload)
    $0 stop
    sleep 1
    $0 start
    exit $?
    ;;
    status)
    echo -n "$DESC: "
    if [ -e $PIDFILE ]; then
    PIDDIR=/proc/$(cat $PIDFILE)
    if [ -d ${PIDDIR} ] && [[ $(readlink -f ${PIDDIR}/exe) == $DAEMON ]]; then
    echo "Running."
    exit 0
    fi
    fi
    echo "Stopped."
    exit 1
    ;;
    version)
    $CAM -V | grep 'Version\|IPv6' | sed 's/Version:[ ]*//' | sed 's/IPv6.*yes/with IPv6/g' | sed 's/IPv6.*no/IPv4-only/g' | sed ':a;N;$!ba;s/\n/ /g'
    ;;
    info)
    $CAM -V | grep 'Version\|IPv6' | sed 's/Version:[ ]*//' | sed 's/IPv6.*yes/with IPv6/g' | sed 's/IPv6.*no/IPv4-only/g' | sed ':a;N;$!ba;s/\n/ /g'
    ;;
    *)
    echo "Usage: $0 start|stop|restart|status"
    exit 1
    ;;
    esac
    exit 0
  • #7
    Gregory*
    Level 10  
    przeqpiciel wrote:
    możesz przejrzeć katalog /etc/rcX.d (gdzie X to 1-6 i znaczy poziom runtime) szczególnie 3 będziesz miał tam pliki w stylu YXXNAZWA.
    Y - S,K Start/Kill
    XX - kolejny numer / kolejnosc uruchamiania
    NAZWA - nazwa uslugi

    Sprawdz zatem czy openvpn startuje przed oscam


    pliki S50softcam oraz S20openvpn z tego co widze sa w rc3.d czy tez rc6.d, z tego by wynikało, że openvpn się wcześniej odpala ale w rzeczywistości tak nie jest, chyba, że coś źle interpertuje ?
  • #8
    n6210
    Level 29  
    Zestawienie tunelu chwilę trwa i pewnie oscam zdąży już wystartować. Z tego samego powodu pokazuje ci najpierw zwykle IP, a potem to z tunelu VPN. Zamiana serwisów miejscami nic ci nie da bo te procesy zachodzą w tle, współbieżnie ze sobą. Żeby opóźnić start oscam musiał byś np monitorować czy interfejs używany przez VPN ma już nadane IP i wtedy startować serwis oscam-a. Ew. cos podobnego tylko np w cronie co kilka sek. odpalać i jak VPN gotowy start oscam...
  • #9
    Gregory*
    Level 10  
    n6210 wrote:
    Zestawienie tunelu chwilę trwa i pewnie oscam zdąży już wystartować. Z tego samego powodu pokazuje ci najpierw zwykle IP, a potem to z tunelu VPN. Zamiana serwisów miejscami nic ci nie da bo te procesy zachodzą w tle, współbieżnie ze sobą. Żeby opóźnić start oscam musiał byś np monitorować czy interfejs używany przez VPN ma już nadane IP i wtedy startować serwis oscam-a. Ew. cos podobnego tylko np w cronie co kilka sek. odpalać i jak VPN gotowy start oscam...


    hmm to już dla mnie wyższa szkoła jazdy, aż tak dobrze Linuxa nie znam a nie będę Cie prosił o takie rzeczy ;) ale chciałbym Cie przy okazji poprosić o co innego bo i tak miałem w planach zakup lepszego routera ac, aby miał też support już we własnym GUI m.in. OpenVPNa a nie przez jakieś dd-wrt etc bo to sporo zachodu aby to instalować, jest jeden fajny router Drayteka 2133ac z obsługą openvpna, generowania do 4 SSID, segregacją ruchu w vlanów, tylko, że kosztuje 8 stówek,
    czy poleciłbyś coś do 200-300 co ma chociaż ac, segregowanie ruchu w vlanach i obsługa openvpna ? tak abym mógł trzymać ruch z/do tego dekodera tylko przez vpna, aby miał coś w rodzaju kill switcha